Open CASCADE Technology: BRepMesh_FaceAttribute Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
BRepMesh_FaceAttribute Class Reference

Auxiliary class for FastDiscret and FastDiscretFace classes. More...

`#include <BRepMesh_FaceAttribute.hxx>`

Inheritance diagram for BRepMesh_FaceAttribute:
[legend]

## Public Member Functions
| BRepMesh_FaceAttribute ()
| Default constructor. More...
| BRepMesh_FaceAttribute (const TopoDS_Face &theFace, const BRepMesh::HDMapOfVertexInteger &theBoundaryVertices, const BRepMesh::HDMapOfIntegerPnt &theBoundaryPoints)
| Constructor. More...
virtual | ~BRepMesh_FaceAttribute ()
| Destructor. More...
main geometrical properties.
const Handle < BRepAdaptor_HSurface > & | Surface () const
| Returns face's surface. More...
void | SetFace (const TopoDS_Face &theFace)
| Sets reference face. More...
const TopoDS_Face & | Face () const
| Returns forward oriented face to be used for calculations. More...
void | SetBoundaryVertices (const BRepMesh::HDMapOfVertexInteger &theVertices)
| Sets boundary vertices map. More...
void | SetBoundaryPoints (const BRepMesh::HDMapOfIntegerPnt &theBoundaryPoints)
| Sets boundary points map. More...
Standard_Real | ToleranceU () const
| Returns U tolerance of face calculated regarding its parameters. More...
Standard_Real | ToleranceV () const
| Returns V tolerance of face calculated regarding its parameters. More...
Standard_Real | GetDefFace () const
| Gives face deflection parameter. More...
void | SetDefFace (const Standard_Real theDefFace)
| Sets face deflection. More...
Standard_Real | GetUMin () const
| Gives minimal value in U domain. More...
void | SetUMin (const Standard_Real theUMin)
| Sets minimal value in U domain. More...
Standard_Real | GetVMin () const
| Gives minimal value in V domain. More...
void | SetVMin (const Standard_Real theVMin)
| Sets minimal value in V domain. More...
Standard_Real | GetUMax () const
| Gives maximal value in U domain. More...
void | SetUMax (const Standard_Real theUMax)
| Sets maximal value in U domain. More...
Standard_Real | GetVMax () const
| Gives maximal value in V domain. More...
void | SetVMax (const Standard_Real theVMax)
| Sets maximal value in V domain. More...
Standard_Real | GetDeltaX () const
| Gives value of step in U domain. More...
void | SetDeltaX (const Standard_Real theDeltaX)
| Sets value of step in U domain. More...
Standard_Real | GetDeltaY () const
| Gives value of step in V domain. More...
void | SetDeltaY (const Standard_Real theDeltaY)
| Sets value of step in V domain. More...
Standard_Integer | GetStatus () const
| Sets set of status flags for this face. More...
void | SetStatus (const BRepMesh_Status theStatus)
| Sets status flag for this face. More...
Standard_Boolean | IsValid () const
| Returns TRUE in case if computed data is valid. More...
auxiliary structures
void | Clear ()
| Clear face attribute. More...
BRepMesh::HDMapOfShapePairOfPolygon & | ChangeInternalEdges ()
| Gives reference to map of internal edges of face. More...
BRepMesh::HDMapOfIntegerListOfXY & | ChangeLocation2D ()
| Gives reference to map of 2D points of discretization. More...
BRepMesh::HDMapOfIntegerPnt & | ChangeSurfacePoints ()
| Gives reference to map of 3D points of discretization. More...
BRepMesh::HDMapOfVertexInteger & | ChangeSurfaceVertices ()
| Gives reference to map of vertices of discretization. More...
BRepMesh::HIMapOfInteger & | ChangeVertexEdgeMap ()
| Gives reference on map of (vertex, edge) pairs of face. More...
Handle < BRepMesh_DataStructureOfDelaun > & | ChangeStructure ()
| Gives Delaunay data structure. More...
BRepMesh::HClassifier & | ChangeClassifier ()
| Returns classifier. More...
BRepMesh::HVectorOfVertex & | ChangeMeshNodes ()
| Returns mesh nodes calculated for boundaries. More...
Point/Vertex/Node manipulators
Standard_Integer | LastPointId () const
| Gives the number of different locations in 3D space. More...
const gp_Pnt & | GetPoint (const BRepMesh_Vertex &theVertex) const
| Gives the 3D location of the vertex. More...
const gp_Pnt & | GetPoint (const Standard_Integer theIndex) const
| Gives the 3D location of the vertex. More...
template<class HVertexExplorer >
Standard_Integer | GetVertexIndex (const HVertexExplorer &theVertexExplorer, const Standard_Boolean isFillEdgeVertices=Standard_False)
| Returns index of the given vertex if it exists in cache, elsewhere adds it to cache and returns cached index. More...
void | AddNode (const Standard_Integer theIndex, const gp_XY &theUV, const BRepMesh_DegreeOfFreedom theMovability, Standard_Integer &theNodeIndex, Standard_Integer &theNodeOnEdgeIndex)
| Adds node with the given parameters to mesh. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual void | Delete () const
| Memory deallocator for transient classes. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Auxiliary methods
gp_XY | Scale (const gp_XY &thePoint2d, const Standard_Boolean isToFaceBasis)
| Scales the given point from real parametric space to face basis and otherwise. More...

## Detailed Description

Auxiliary class for FastDiscret and FastDiscretFace classes.

## Constructor & Destructor Documentation

BRepMesh_FaceAttribute::BRepMesh_FaceAttribute | ( |  | ) |

Default constructor.

BRepMesh_FaceAttribute::BRepMesh_FaceAttribute | ( | const TopoDS_Face & | theFace,
|  | const BRepMesh::HDMapOfVertexInteger & | theBoundaryVertices,
|  | const BRepMesh::HDMapOfIntegerPnt & | theBoundaryPoints
| ) |  |

Constructor.

Parameters

  theFace | face the attribute is created for. Used for default initialization. Attribute keeps reference to the source face with forward orientation.
  theBoundaryVertices | shared map of shape vertices.
  theBoundaryPoints | shared discretization points of shape boundaries.

virtual BRepMesh_FaceAttribute::~BRepMesh_FaceAttribute | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

void BRepMesh_FaceAttribute::AddNode | ( | const Standard_Integer | theIndex,
|  | const gp_XY & | theUV,
|  | const BRepMesh_DegreeOfFreedom | theMovability,
|  | Standard_Integer & | theNodeIndex,
|  | Standard_Integer & | theNodeOnEdgeIndex
| ) |  |

Adds node with the given parameters to mesh.

Parameters

  theIndex | index of 3D point corresponded to the node.
  theUV | node position.
  theMovability | movability of a node.
  theNodeIndex | index of vertex in mesh structure.
  theNodeOnEdgeIndex | ordered index of node on the boundary.

BRepMesh::HClassifier& BRepMesh_FaceAttribute::ChangeClassifier | ( |  | ) |
| inline

Returns classifier.

BRepMesh::HDMapOfShapePairOfPolygon& BRepMesh_FaceAttribute::ChangeInternalEdges | ( |  | ) |
| inline

Gives reference to map of internal edges of face.

BRepMesh::HDMapOfIntegerListOfXY& BRepMesh_FaceAttribute::ChangeLocation2D | ( |  | ) |
| inline

Gives reference to map of 2D points of discretization.

BRepMesh::HVectorOfVertex& BRepMesh_FaceAttribute::ChangeMeshNodes | ( |  | ) |
| inline

Returns mesh nodes calculated for boundaries.

Handle< BRepMesh_DataStructureOfDelaun >& BRepMesh_FaceAttribute::ChangeStructure | ( |  | ) |
| inline

Gives Delaunay data structure.

BRepMesh::HDMapOfIntegerPnt& BRepMesh_FaceAttribute::ChangeSurfacePoints | ( |  | ) |
| inline

Gives reference to map of 3D points of discretization.

BRepMesh::HDMapOfVertexInteger& BRepMesh_FaceAttribute::ChangeSurfaceVertices | ( |  | ) |
| inline

Gives reference to map of vertices of discretization.

BRepMesh::HIMapOfInteger& BRepMesh_FaceAttribute::ChangeVertexEdgeMap | ( |  | ) |
| inline

Gives reference on map of (vertex, edge) pairs of face.

void BRepMesh_FaceAttribute::Clear | ( |  | ) |

Clear face attribute.

const TopoDS_Face& BRepMesh_FaceAttribute::Face | ( |  | ) | const
| inline

Returns forward oriented face to be used for calculations.

Standard_Real BRepMesh_FaceAttribute::GetDefFace | ( |  | ) | const
| inline

Gives face deflection parameter.

Standard_Real BRepMesh_FaceAttribute::GetDeltaX | ( |  | ) | const
| inline

Gives value of step in U domain.

Standard_Real BRepMesh_FaceAttribute::GetDeltaY | ( |  | ) | const
| inline

Gives value of step in V domain.

const gp_Pnt& BRepMesh_FaceAttribute::GetPoint | ( | const BRepMesh_Vertex & | theVertex | ) | const
| inline

Gives the 3D location of the vertex.

const gp_Pnt& BRepMesh_FaceAttribute::GetPoint | ( | const Standard_Integer | theIndex | ) | const
| inline

Gives the 3D location of the vertex.

Standard_Integer BRepMesh_FaceAttribute::GetStatus | ( |  | ) | const
| inline

Sets set of status flags for this face.

Standard_Real BRepMesh_FaceAttribute::GetUMax | ( |  | ) | const
| inline

Gives maximal value in U domain.

Standard_Real BRepMesh_FaceAttribute::GetUMin | ( |  | ) | const
| inline

Gives minimal value in U domain.

template<class HVertexExplorer >

Standard_Integer BRepMesh_FaceAttribute::GetVertexIndex | ( | const HVertexExplorer & | theVertexExplorer,
|  | const Standard_Boolean | isFillEdgeVertices = `Standard_False`
| ) |  |
| inline

Returns index of the given vertex if it exists in cache, elsewhere adds it to cache and returns cached index.

Parameters

  theVertexExplorer | template parameter intended to transfer parameters of vertex to method. Explorer class can implement different approaches of extraction of target parameters.
  isFillEdgeVertices | if TRUE adds vertex to shared map of edges vertices, elsewhere adds it map of face vertices.

Standard_Real BRepMesh_FaceAttribute::GetVMax | ( |  | ) | const
| inline

Gives maximal value in V domain.

Standard_Real BRepMesh_FaceAttribute::GetVMin | ( |  | ) | const
| inline

Gives minimal value in V domain.

Standard_Boolean BRepMesh_FaceAttribute::IsValid | ( |  | ) | const
| inline

Returns TRUE in case if computed data is valid.

Standard_Integer BRepMesh_FaceAttribute::LastPointId | ( |  | ) | const
| inline

Gives the number of different locations in 3D space.

gp_XY BRepMesh_FaceAttribute::Scale | ( | const gp_XY & | thePoint2d,
|  | const Standard_Boolean | isToFaceBasis
| ) |  |

Scales the given point from real parametric space to face basis and otherwise.

Parameters

  thePoint2d | point to be scaled.
  isToFaceBasis | if TRUE converts point to face basis, otherwise performs reverse conversion.

Returns
  scaled point.

void BRepMesh_FaceAttribute::SetBoundaryPoints | ( | const BRepMesh::HDMapOfIntegerPnt & | theBoundaryPoints | ) |
| inline

Sets boundary points map.

void BRepMesh_FaceAttribute::SetBoundaryVertices | ( | const BRepMesh::HDMapOfVertexInteger & | theVertices | ) |
| inline

Sets boundary vertices map.

void BRepMesh_FaceAttribute::SetDefFace | ( | const Standard_Real | theDefFace | ) |
| inline

Sets face deflection.

void BRepMesh_FaceAttribute::SetDeltaX | ( | const Standard_Real | theDeltaX | ) |
| inline

Sets value of step in U domain.

void BRepMesh_FaceAttribute::SetDeltaY | ( | const Standard_Real | theDeltaY | ) |
| inline

Sets value of step in V domain.

void BRepMesh_FaceAttribute::SetFace | ( | const TopoDS_Face & | theFace | ) |
| inline

Sets reference face.

void BRepMesh_FaceAttribute::SetStatus | ( | const BRepMesh_Status | theStatus | ) |
| inline

Sets status flag for this face.

void BRepMesh_FaceAttribute::SetUMax | ( | const Standard_Real | theUMax | ) |
| inline

Sets maximal value in U domain.

void BRepMesh_FaceAttribute::SetUMin | ( | const Standard_Real | theUMin | ) |
| inline

Sets minimal value in U domain.

void BRepMesh_FaceAttribute::SetVMax | ( | const Standard_Real | theVMax | ) |
| inline

Sets maximal value in V domain.

void BRepMesh_FaceAttribute::SetVMin | ( | const Standard_Real | theVMin | ) |
| inline

Sets minimal value in V domain.

const Handle< BRepAdaptor_HSurface >& BRepMesh_FaceAttribute::Surface | ( |  | ) | const
| inline

Returns face's surface.

Standard_Real BRepMesh_FaceAttribute::ToleranceU | ( |  | ) | const

Returns U tolerance of face calculated regarding its parameters.

Standard_Real BRepMesh_FaceAttribute::ToleranceV | ( |  | ) | const

Returns V tolerance of face calculated regarding its parameters.

The documentation for this class was generated from the following file:

- BRepMesh_FaceAttribute.hxx